﻿using Microsoft.Web.WebView2.Core;
using Microsoft.Web.WebView2.WinForms;
using System;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace WordAddInTest2024
{
    public class Bridge
    {
        public static Bridge bridge = new Bridge();

        private static Dictionary<string, WebView2> webViewDict = new Dictionary<string, WebView2>();


        public async static void InitWebEnvAsync(string name, WebView2 webView)
        {
            webView.Name = name;
            if (webViewDict.ContainsKey(webView.Name))
            {
                webViewDict[name] = webView;
            }
            else
            {
                webViewDict.Add(name,webView);
            }
            
            // 禁用web安全，允许跨域 否则需要web编译为umd加载模式
            var ops = new CoreWebView2EnvironmentOptions("--disable-web-security");
            var env = await CoreWebView2Environment.CreateAsync(null, null, ops);
            await webView.EnsureCoreWebView2Async(env);
            // 添加 js与客户端代理
            webView.CoreWebView2.AddHostObjectToScript("bridge", bridge);
        }
    }
}
